#!/opt/bin/bash
#
# script to facilitate server-side transcoding of ogg files
#
#
# Usage: mt-daapd-ssc.sh <filename> <offset> <length in seconds>
#
# You may need to fix these paths:
#

WAVSTREAMER=/opt/bin/wavstreamer
OGGDEC=/opt/bin/oggdec
FLAC=/opt/bin/flac

SERVICEDIR=/home/user/peller/sbservices

# Would be nice to get this from mt-daapd
DEVICEIP=192.168.0.101

FILE=$1
OFFSET=${2-0}

NAME=${FILE##*/}
BASE=${NAME%.*}
EXT=${NAME##*.}

ogg_file() {
    $OGGDEC --quiet -o - "$FILE" | $WAVSTREAMER -o $OFFSET $FORGELEN
}


flac_file() {
    $FLAC --silent --decode --stdout "$FILE" | $WAVSTREAMER -o $OFFSET $FORGELEN
}

service() {
    cd $SERVICEDIR/$BASE; php run.php $DEVICEIP 2>&1 > /dev/null
}

#if [ "$2" == "" ]; then
#    OFFSET=0
#else
#    OFFSET=$2
#fi

if [ "$3" != "" ]; then
    FORGELEN="-l $3"
fi

if [ "$EXT" == "ogg" ]; then
    ogg_file
    exit;
fi

if [ "$EXT" == "flac" ]; then
    flac_file
    exit;
fi

if [ "$EXT" == "svc" ]; then
    service
    exit;
fi

#
# here you could cat a generic "error" wav...
#
#
# cat /path/to/error.wav
#
