<?php

function open_pgm_bitmap($filename) {
  $fp = fopen($filename, 'rb');
  if (!$fp)
    return false;

  $magic = fgets($fp, 512);
  $scale = true;
  if (strpos($magic, 'P5') == 0) {
    $raw = true;
  }
  else if (strpos($magic, 'P2') == 0) {
    $raw = false;
  }
  else if (strpos($magic, 'P1') == 0) {
    $raw = false;
    $scale = false;
  }
  else {
    echo "unknown $magic\n";
    return false;
  }

  while (strpos($dim = fgets($fp, 512), '#', 0) !== FALSE);

  list ($w, $h) = split(" ", $dim, 2);

  if ($scale)
    $scale = fgets($fp, 16);

  $matrix = array();
  for ($i = 0; $i < $h; $i++) {
    if ($raw)
      $row = fgets($fp, $w+1);
    for ($j = 0; $j < $w; $j++) {
      if ($raw)
	$value = ord(substr($row, $j, 1));
      else
	$value = fgets($fp, 16); //FIX

      $matrix[$i][$j] = $scale ? $value / $scale : $value;
    }
  }

  fclose($fp);
  return $matrix;
}

function dumpMatrix(&$matrix, $threshold)
{
  $h = count($matrix);
  $w = count($matrix[0]);
  for ($i = 0; $i < $h; $i++) {
    for ($j = 0; $j < $w; $j++) {
      if ($matrix[$i][$j] < $threshold)
	echo "X";
      else
	echo " ";
    }
    echo "\n";
  }
}

?>
