<?php
// (c) Adam Peller - peller@gnu.org

require_once 'sb.php';
require_once 'XML/RSS.php';
require_once 'pgm.php';

class RSSRenderer {

 var $sbip;
 var $rss;
 var $delay;
 var $icon;

 function RSSRenderer($sbip, $feed, $delay = 20, $icon = null) {
   $this->sbip = $sbip;
   $this->rss =& new XML_RSS($feed);
   $this->rss->parse();
   $this->delay = $delay;
   $this->icon = $icon;
 }

 private function paintSoundBridge(&$items, $delay)
 {
  $sb =& new SoundBridge($this->sbip);
  if (!$sb) {
    die("Unable to connect to SoundBridge at ip=".$this->sbip);
  }

  $matrix = open_pgm_bitmap($this->icon);
  $sb->enterSketch();

  foreach ($items as $item) {
    $title = addslashes($item['title']);
    $desc = addslashes($item['description']);
    $sb->draw('clear');
echo "RSS Item: $title\n";
    $sb->wrap($title, count($matrix[0])+2);
    $THRESHOLD = 0.7;
    if ($matrix)
      $sb->drawMatrix($matrix, $THRESHOLD, 0, 0, 1, 1);

    sleep($delay);
echo "$desc\n";
    $sb->draw('clear');
    $sb->marquee($desc, $delay);
  }

  $sb->exitSketch();
  $sb->close();
 }

 function paint() {
   $this->paintSoundBridge($this->rss->getItems(), $this->delay);
 }
}

?>
